import { OnInit, Type } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { eLayoutType } from '../enums/common';
import { LocalizationService } from '../services/localization.service';
import { ReplaceableComponentsService } from '../services/replaceable-components.service';
import { RouterEvents } from '../services/router-events.service';
import { RoutesService } from '../services/routes.service';
import { SubscriptionService } from '../services/subscription.service';
import { EnvironmentService } from '../services';
import * as i0 from "@angular/core";
export declare class DynamicLayoutComponent implements OnInit {
    layout?: Type<any>;
    layoutKey?: eLayoutType;
    readonly layouts: Map<string, string>;
    isLayoutVisible: boolean;
    protected readonly router: Router;
    protected readonly route: ActivatedRoute;
    protected readonly routes: RoutesService;
    protected readonly localizationService: LocalizationService;
    protected readonly replaceableComponents: ReplaceableComponentsService;
    protected readonly subscription: SubscriptionService;
    protected readonly routerEvents: RouterEvents;
    protected readonly environment: EnvironmentService;
    constructor(dynamicLayoutComponent: DynamicLayoutComponent);
    ngOnInit(): void;
    private checkLayoutOnNavigationEnd;
    private getLayout;
    private getExtractedLayout;
    showLayoutNotFoundError(layoutName: string): void;
    private listenToLanguageChange;
    private getComponent;
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicLayoutComponent, [{ optional: true; skipSelf: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicLayoutComponent, "abp-dynamic-layout", never, {}, {}, never, never, false, never>;
}
