import { ModuleWithProviders } from '@angular/core';
import { ABP } from './models/common';
import './utils/date-extensions';
import * as i0 from "@angular/core";
import * as i1 from "./abstracts/ng-model.component";
import * as i2 from "./components/dynamic-layout.component";
import * as i3 from "./components/replaceable-route-container.component";
import * as i4 from "./components/router-outlet.component";
import * as i5 from "./pipes/sort.pipe";
import * as i6 from "./pipes/safe-html.pipe";
import * as i7 from "./pipes/to-injector.pipe";
import * as i8 from "./pipes/short-date-time.pipe";
import * as i9 from "./pipes/short-time.pipe";
import * as i10 from "./pipes/short-date.pipe";
import * as i11 from "@angular/common";
import * as i12 from "@angular/forms";
import * as i13 from "@angular/router";
import * as i14 from "./localization.module";
import * as i15 from "./pipes/utc-to-local.pipe";
import * as i16 from "./directives/autofocus.directive";
import * as i17 from "./directives/debounce.directive";
import * as i18 from "./directives/for.directive";
import * as i19 from "./directives/form-submit.directive";
import * as i20 from "./directives/init.directive";
import * as i21 from "./directives/permission.directive";
import * as i22 from "./directives/replaceable-template.directive";
import * as i23 from "./directives/stop-propagation.directive";
/**
 * BaseCoreModule is the module that holds
 * all imports, declarations, exports, and entryComponents
 * but not the providers.
 * This module will be imported and exported by all others.
 */
export declare class BaseCoreModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<BaseCoreModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<BaseCoreModule, [typeof i1.AbstractNgModelComponent, typeof i2.DynamicLayoutComponent, typeof i3.ReplaceableRouteContainerComponent, typeof i4.RouterOutletComponent, typeof i5.SortPipe, typeof i6.SafeHtmlPipe, typeof i7.ToInjectorPipe, typeof i8.ShortDateTimePipe, typeof i9.ShortTimePipe, typeof i10.ShortDatePipe], [typeof i11.CommonModule, typeof i12.FormsModule, typeof i12.ReactiveFormsModule, typeof i13.RouterModule, typeof i14.LocalizationModule, typeof i15.UtcToLocalPipe, typeof i16.AutofocusDirective, typeof i17.InputEventDebounceDirective, typeof i18.ForDirective, typeof i19.FormSubmitDirective, typeof i20.InitDirective, typeof i21.PermissionDirective, typeof i22.ReplaceableTemplateDirective, typeof i23.StopPropagationDirective], [typeof i11.CommonModule, typeof i12.FormsModule, typeof i12.ReactiveFormsModule, typeof i13.RouterModule, typeof i14.LocalizationModule, typeof i1.AbstractNgModelComponent, typeof i2.DynamicLayoutComponent, typeof i3.ReplaceableRouteContainerComponent, typeof i4.RouterOutletComponent, typeof i5.SortPipe, typeof i6.SafeHtmlPipe, typeof i7.ToInjectorPipe, typeof i8.ShortDateTimePipe, typeof i9.ShortTimePipe, typeof i10.ShortDatePipe, typeof i16.AutofocusDirective, typeof i17.InputEventDebounceDirective, typeof i18.ForDirective, typeof i19.FormSubmitDirective, typeof i20.InitDirective, typeof i21.PermissionDirective, typeof i22.ReplaceableTemplateDirective, typeof i23.StopPropagationDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<BaseCoreModule>;
}
/**
 * RootCoreModule is the module that will be used at root level
 * and it introduces imports useful at root level (e.g. NGXS)
 */
export declare class RootCoreModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<RootCoreModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<RootCoreModule, never, [typeof BaseCoreModule, typeof i14.LocalizationModule], [typeof BaseCoreModule, typeof i14.LocalizationModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<RootCoreModule>;
}
/**
 * CoreModule is the module that is publicly available
 */
export declare class CoreModule {
    /**
     * @deprecated forRoot method is deprecated, use `provideAbpCore` *function* for config settings.
     */
    static forRoot(options?: ABP.Root): ModuleWithProviders<RootCoreModule>;
    /**
     * @deprecated forChild method is deprecated, use `provideAbpCoreChild` *function* for config settings.
     */
    static forChild(options?: ABP.Child): ModuleWithProviders<RootCoreModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<CoreModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<CoreModule, never, [typeof BaseCoreModule], [typeof BaseCoreModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<CoreModule>;
}
