import { Injector, OnChanges, OnInit, SimpleChanges, TemplateRef, Type, ViewContainerRef } from '@angular/core';
import { Subscription } from 'rxjs';
import { ABP } from '../models/common';
import { ReplaceableComponents } from '../models/replaceable-components';
import { ReplaceableComponentsService } from '../services/replaceable-components.service';
import { SubscriptionService } from '../services/subscription.service';
import * as i0 from "@angular/core";
export declare class ReplaceableTemplateDirective implements OnInit, OnChanges {
    private injector;
    private templateRef;
    private vcRef;
    private replaceableComponents;
    private subscription;
    data: ReplaceableComponents.ReplaceableTemplateDirectiveInput<any, any>;
    providedData: ReplaceableComponents.ReplaceableTemplateData<any, any>;
    context: any;
    externalComponent: Type<any>;
    defaultComponentRef: any;
    defaultComponentSubscriptions: ABP.Dictionary<Subscription>;
    initialized: boolean;
    constructor(injector: Injector, templateRef: TemplateRef<any>, vcRef: ViewContainerRef, replaceableComponents: ReplaceableComponentsService, subscription: SubscriptionService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    setDefaultComponentInputs(): void;
    setProvidedData(): void;
    resetDefaultComponent(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ReplaceableTemplateDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ReplaceableTemplateDirective, "[abpReplaceableTemplate]", never, { "data": { "alias": "abpReplaceableTemplate"; "required": false; }; }, {}, never, never, true, never>;
}
