import { Provider } from '@angular/core';
import { ABP, SortableItem } from '../models';
export declare enum CoreFeatureKind {
    Options = 0,
    CompareFunctionFactory = 1,
    TitleStrategy = 2
}
export interface CoreFeature<KindT extends CoreFeatureKind> {
    ɵkind: KindT;
    ɵproviders: Provider[];
}
export declare function withOptions(options?: ABP.Root): CoreFeature<CoreFeatureKind.Options>;
export declare function withTitleStrategy(strategy: unknown): CoreFeature<CoreFeatureKind.TitleStrategy>;
export declare function withCompareFuncFactory(factory: (a: SortableItem, b: SortableItem) => 1 | -1 | 0): CoreFeature<CoreFeatureKind.CompareFunctionFactory>;
export declare function provideAbpCore(...features: CoreFeature<CoreFeatureKind>[]): import("@angular/core").EnvironmentProviders;
export declare function provideAbpCoreChild(options?: ABP.Child): import("@angular/core").EnvironmentProviders;
