import { Observable } from 'rxjs';
import { AbpApplicationConfigurationService } from '../proxy/volo/abp/asp-net-core/mvc/application-configurations/abp-application-configuration.service';
import { AbpApplicationLocalizationService } from '../proxy/volo/abp/asp-net-core/mvc/application-configurations/abp-application-localization.service';
import { ApplicationConfigurationDto, ApplicationGlobalFeatureConfigurationDto } from '../proxy/volo/abp/asp-net-core/mvc/application-configurations/models';
import * as i0 from "@angular/core";
export declare class ConfigStateService {
    private abpConfigService;
    private abpApplicationLocalizationService;
    private readonly includeLocalizationResources;
    private updateSubject;
    private readonly store;
    uiCultureFromAuthCodeFlow: string;
    setState(config: ApplicationConfigurationDto): void;
    get createOnUpdateStream(): <Slice>(selector: (state: {
        localization?: {
            values?: {
                [x: string]: {
                    [x: string]: string;
                };
            };
            resources?: {
                [x: string]: {
                    texts?: {
                        [x: string]: string;
                    };
                    baseResources?: string[];
                };
            };
            languages?: import("@abp/ng.core").LanguageInfo[];
            currentCulture?: {
                displayName?: string;
                englishName?: string;
                threeLetterIsoLanguageName?: string;
                twoLetterIsoLanguageName?: string;
                isRightToLeft?: boolean;
                cultureName?: string;
                name?: string;
                nativeName?: string;
                dateTimeFormat?: {
                    calendarAlgorithmType?: string;
                    dateTimeFormatLong?: string;
                    shortDatePattern?: string;
                    fullDateTimePattern?: string;
                    dateSeparator?: string;
                    shortTimePattern?: string;
                    longTimePattern?: string;
                };
            };
            defaultResourceName?: string;
            languagesMap?: {
                [x: string]: import("@abp/ng.core").NameValue<string>[];
            };
            languageFilesMap?: {
                [x: string]: import("@abp/ng.core").NameValue<string>[];
            };
        };
        auth?: {
            grantedPolicies?: {
                [x: string]: boolean;
            };
        };
        setting?: {
            values?: {
                [x: string]: string;
            };
        };
        currentUser?: {
            isAuthenticated?: boolean;
            id?: string;
            tenantId?: string;
            impersonatorUserId?: string;
            impersonatorTenantId?: string;
            impersonatorUserName?: string;
            impersonatorTenantName?: string;
            userName?: string;
            name?: string;
            surName?: string;
            email?: string;
            emailVerified?: boolean;
            phoneNumber?: string;
            phoneNumberVerified?: boolean;
            roles?: string[];
        };
        features?: {
            values?: {
                [x: string]: string;
            };
        };
        globalFeatures?: {
            enabledFeatures?: string[];
        };
        multiTenancy?: {
            isEnabled?: boolean;
        };
        currentTenant?: {
            id?: string;
            name?: string;
            isAvailable?: boolean;
        };
        timing?: {
            timeZone?: {
                iana?: {
                    timeZoneName?: string;
                };
                windows?: {
                    timeZoneId?: string;
                };
            };
        };
        clock?: {
            kind?: string;
        };
        objectExtensions?: {
            modules?: {
                [x: string]: {
                    entities?: {
                        [x: string]: {
                            properties?: {
                                [x: string]: {
                                    type?: string;
                                    typeSimple?: string;
                                    displayName?: {
                                        name?: string;
                                        resource?: string;
                                    };
                                    api?: {
                                        onGet?: {
                                            isAvailable?: boolean;
                                        };
                                        onCreate?: {
                                            isAvailable?: boolean;
                                        };
                                        onUpdate?: {
                                            isAvailable?: boolean;
                                        };
                                    };
                                    ui?: {
                                        onTable?: {
                                            isVisible?: boolean;
                                        };
                                        onCreateForm?: {
                                            isVisible?: boolean;
                                        };
                                        onEditForm?: {
                                            isVisible?: boolean;
                                        };
                                        lookup?: {
                                            url?: string;
                                            resultListPropertyName?: string;
                                            displayPropertyName?: string;
                                            valuePropertyName?: string;
                                            filterParamName?: string;
                                        };
                                    };
                                    attributes?: import("@abp/ng.core").ExtensionPropertyAttributeDto[];
                                    configuration?: {
                                        [x: string]: object;
                                    };
                                    defaultValue?: object;
                                };
                            };
                            configuration?: {
                                [x: string]: object;
                            };
                        };
                    };
                    configuration?: {
                        [x: string]: object;
                    };
                };
            };
            enums?: {
                [x: string]: {
                    fields?: import("@abp/ng.core").ExtensionEnumFieldDto[];
                    localizationResource?: string;
                };
            };
        };
        extraProperties?: {
            [x: string]: object;
        };
    }) => Slice, filterFn?: (x: Slice) => boolean) => Observable<Slice>;
    constructor(abpConfigService: AbpApplicationConfigurationService, abpApplicationLocalizationService: AbpApplicationLocalizationService, includeLocalizationResources: boolean | null);
    private initUpdateStream;
    private getLocalizationAndCombineWithAppState;
    private getlocalizationResource;
    refreshAppState(): Observable<{
        localization?: {
            values?: {
                [x: string]: {
                    [x: string]: string;
                };
            };
            resources?: {
                [x: string]: {
                    texts?: {
                        [x: string]: string;
                    };
                    baseResources?: string[];
                };
            };
            languages?: import("@abp/ng.core").LanguageInfo[];
            currentCulture?: {
                displayName?: string;
                englishName?: string;
                threeLetterIsoLanguageName?: string;
                twoLetterIsoLanguageName?: string;
                isRightToLeft?: boolean;
                cultureName?: string;
                name?: string;
                nativeName?: string;
                dateTimeFormat?: {
                    calendarAlgorithmType?: string;
                    dateTimeFormatLong?: string;
                    shortDatePattern?: string;
                    fullDateTimePattern?: string;
                    dateSeparator?: string;
                    shortTimePattern?: string;
                    longTimePattern?: string;
                };
            };
            defaultResourceName?: string;
            languagesMap?: {
                [x: string]: import("@abp/ng.core").NameValue<string>[];
            };
            languageFilesMap?: {
                [x: string]: import("@abp/ng.core").NameValue<string>[];
            };
        };
        auth?: {
            grantedPolicies?: {
                [x: string]: boolean;
            };
        };
        setting?: {
            values?: {
                [x: string]: string;
            };
        };
        currentUser?: {
            isAuthenticated?: boolean;
            id?: string;
            tenantId?: string;
            impersonatorUserId?: string;
            impersonatorTenantId?: string;
            impersonatorUserName?: string;
            impersonatorTenantName?: string;
            userName?: string;
            name?: string;
            surName?: string;
            email?: string;
            emailVerified?: boolean;
            phoneNumber?: string;
            phoneNumberVerified?: boolean;
            roles?: string[];
        };
        features?: {
            values?: {
                [x: string]: string;
            };
        };
        globalFeatures?: {
            enabledFeatures?: string[];
        };
        multiTenancy?: {
            isEnabled?: boolean;
        };
        currentTenant?: {
            id?: string;
            name?: string;
            isAvailable?: boolean;
        };
        timing?: {
            timeZone?: {
                iana?: {
                    timeZoneName?: string;
                };
                windows?: {
                    timeZoneId?: string;
                };
            };
        };
        clock?: {
            kind?: string;
        };
        objectExtensions?: {
            modules?: {
                [x: string]: {
                    entities?: {
                        [x: string]: {
                            properties?: {
                                [x: string]: {
                                    type?: string;
                                    typeSimple?: string;
                                    displayName?: {
                                        name?: string;
                                        resource?: string;
                                    };
                                    api?: {
                                        onGet?: {
                                            isAvailable?: boolean;
                                        };
                                        onCreate?: {
                                            isAvailable?: boolean;
                                        };
                                        onUpdate?: {
                                            isAvailable?: boolean;
                                        };
                                    };
                                    ui?: {
                                        onTable?: {
                                            isVisible?: boolean;
                                        };
                                        onCreateForm?: {
                                            isVisible?: boolean;
                                        };
                                        onEditForm?: {
                                            isVisible?: boolean;
                                        };
                                        lookup?: {
                                            url?: string;
                                            resultListPropertyName?: string;
                                            displayPropertyName?: string;
                                            valuePropertyName?: string;
                                            filterParamName?: string;
                                        };
                                    };
                                    attributes?: import("@abp/ng.core").ExtensionPropertyAttributeDto[];
                                    configuration?: {
                                        [x: string]: object;
                                    };
                                    defaultValue?: object;
                                };
                            };
                            configuration?: {
                                [x: string]: object;
                            };
                        };
                    };
                    configuration?: {
                        [x: string]: object;
                    };
                };
            };
            enums?: {
                [x: string]: {
                    fields?: import("@abp/ng.core").ExtensionEnumFieldDto[];
                    localizationResource?: string;
                };
            };
        };
        extraProperties?: {
            [x: string]: object;
        };
    }>;
    refreshLocalization(lang: string): Observable<null>;
    getOne$<K extends keyof ApplicationConfigurationDto>(key: K): Observable<ApplicationConfigurationDto[K]>;
    getOne<K extends keyof ApplicationConfigurationDto>(key: K): ApplicationConfigurationDto[K];
    getAll$(): Observable<ApplicationConfigurationDto>;
    getAll(): ApplicationConfigurationDto;
    getDeep$(keys: string[] | string): Observable<any>;
    getDeep(keys: string[] | string): any;
    getFeature(key: string): string;
    getFeature$(key: string): Observable<string>;
    getFeatures(keys: string[]): {};
    getFeatures$(keys: string[]): Observable<{
        [key: string]: string;
    } | undefined>;
    private isFeatureEnabled;
    getFeatureIsEnabled(key: string): boolean;
    getFeatureIsEnabled$(key: string): Observable<boolean>;
    getSetting(key: string): string;
    getSetting$(key: string): Observable<string>;
    getSettings(keyword?: string): Record<string, string>;
    getSettings$(keyword?: string): Observable<Record<string, string>>;
    getGlobalFeatures(): ApplicationGlobalFeatureConfigurationDto;
    getGlobalFeatures$(): Observable<ApplicationGlobalFeatureConfigurationDto>;
    private isGlobalFeatureEnabled;
    getGlobalFeatureIsEnabled(key: string): boolean;
    getGlobalFeatureIsEnabled$(key: string): Observable<boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfigStateService, [null, null, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ConfigStateService>;
}
