import { Injector, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { ABP } from '../models/common';
import { PagedResultDto } from '../models/dtos';
import * as i0 from "@angular/core";
export type RequestStatus = 'idle' | 'loading' | 'success' | 'error';
export declare class ListService<QueryParamsType = ABP.PageQueryParams | any> implements OnDestroy {
    private _filter;
    set filter(value: string);
    get filter(): string;
    private _maxResultCount;
    set maxResultCount(value: number);
    get maxResultCount(): number;
    private _page;
    set page(value: number);
    get page(): number;
    private _totalCount;
    set totalCount(value: number);
    get totalCount(): number;
    private _sortKey;
    set sortKey(value: string);
    get sortKey(): string;
    private _sortOrder;
    set sortOrder(value: string);
    get sortOrder(): string;
    private _query$;
    get query$(): Observable<QueryParamsType>;
    private _isLoading$;
    private _requestStatus;
    private destroy$;
    private delay;
    /**
     * @deprecated Use `requestStatus$` instead.
     */
    get isLoading$(): Observable<boolean>;
    get requestStatus$(): Observable<RequestStatus>;
    get: () => void;
    getWithoutPageReset: () => void;
    constructor(injector: Injector);
    hookToQuery<T>(streamCreatorCallback: QueryStreamCreatorCallback<T, QueryParamsType>): Observable<PagedResultDto<T>>;
    ngOnDestroy(): void;
    private resetPageWhenUnchanged;
    private next;
    static ɵfac: i0.ɵɵFactoryDeclaration<ListService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ListService<any>>;
}
export type QueryStreamCreatorCallback<T, QueryParamsType = ABP.PageQueryParams> = (query: QueryParamsType) => Observable<PagedResultDto<T>>;
