export declare class CrossOriginStrategy {
    crossorigin: 'anonymous' | 'use-credentials' | null;
    integrity?: string;
    constructor(crossorigin: 'anonymous' | 'use-credentials' | null, integrity?: string);
    setCrossOrigin<T extends HTMLElement>(element: T): void;
}
export declare class NoCrossOriginStrategy extends CrossOriginStrategy {
    setCrossOrigin(): void;
}
export declare const CROSS_ORIGIN_STRATEGY: {
    Anonymous(integrity?: string): CrossOriginStrategy;
    UseCredentials(integrity?: string): CrossOriginStrategy;
    None(): NoCrossOriginStrategy;
};
